//+------------------------------------------------------------------+
//|                                                           17.mq4 |
//|                                                               gi |
//|                                                                  |
//+------------------------------------------------------------------+
//|                                                                       |
//|                                                                  |
//+------------------------------------------------------------------+


#property copyright "gi"
#property link      ""
#property version   "1.00"
#property strict
//+------------------------------------------------------------------+
input   int Dist_TP=11;                              //  TP (pt)
input   double Lot=0.01;                          // 
//+------------------------------------------------------------------+
   double Old_Price;                   // a (Bid,)
   double Price;                     //   
   double TP;                        //  
   int dig;                     // -    3  1
   int i,k,l,p,r;
   double Poin;                     //   ( TP)
   string Symb;                        // . 
   string Order_Tip[4];
   int Order_Type;
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
//---
//   Alert ("-----------------------------");
   Symb=Symbol();                        
   dig=Digits-1;                      
   Poin=Point;                     
   if (dig==2||dig==4)
      {
      dig--;
      Poin*=10;
      }                    
//   Order_Type[] = {2,4,3,5};         //   :
//   2-, 4-, 3- ,5-  
//   Order_Tip[4] = {"BUYLIMIT","BUYSTOP","SELLLIMIT","SELLSTOP"};

//---
   return(0);
  }
//--------------------------------------------------------------- 1 --
 void OnTick()                                     // . OnTick
  {
//+------------------------------------------------------------------+
 // Alert("tik!");
//+------------------------------------------------------------------+
   Old_Price=NormalizeDouble(Bid,dig); //   
   double Price_Minus=Old_Price-10*Poin;
   double Price_Plus=Old_Price+10*Poin;
   int Flag[4]={0,0,0,0};                //     
   l=0;//-  
   p=0;//     1 -10, 2  +10,0- 
   r=0;                                 
   int Ord_Tot=OrdersTotal();                 //  
//--------------------------------------------------------------- 2 --
   for(k=1; k<=Ord_Tot; k++)          //   
     {     
      if ((Flag[0]+Flag[1]+Flag[2]+Flag[3])==4) break;                     //   4  
      if (OrderSelect(k-1,SELECT_BY_POS)==true) //   
        {                                       //  :                         
         l++;
         string Ord_Sy=OrderSymbol();
         if (Ord_Sy!= Symb) continue;    //   ..
         int Tip=OrderType();                   //  
         double Open_Price=NormalizeDouble(OrderOpenPrice(),dig); //    
         p=GI_01(Open_Price,Price_Minus,Price_Plus);
         if (p==0)continue;
         r++;     //   
         if (p==1&&(Tip==0||Tip==2))            //  BuyLimit  
            {
                Flag[0]=1;
 //               Alert(" BuyLimit  ");
                continue;
            }    
         if (p==1&&(Tip==1||Tip==5))            //  SellStop  
            {
               Flag[3]=1;
  //             Alert(" SellStop  "); 
               continue;
            }
         if (p==2&&(Tip==0||Tip==4))
            {
               Flag[1]=1;
  //             Alert(" BuyStop  ");      //  BuyStop  
               continue;
            }
         if (p==2&&(Tip==1||Tip==3))            //  SellLimit  
            {
               Flag[2]=1;
//               Alert(" SellLimit  "); 
            }
        }
                 
     }                                          //  .
 //---------------------------------------------------------  --
     //      
     //   
     //---------------------------------------------------------  --
     for(i=0;i<=3;i++) 
         {
          if (Flag[i]==0)
            {
       //      
             switch(i)                        
                {    
                  case 0: Price=Old_Price-10*Poin;                 
                          TP=Old_Price+(Dist_TP-10)*Poin;
                          Order_Type=2;
                          break;
                  case 1: Price=Old_Price+10*Poin;
                          TP=Old_Price+(Dist_TP+10)*Poin;
                          Order_Type=4;                         
                          break;          
                  case 2: Price=Old_Price+Dist_TP*Poin;
                          TP=Old_Price;
                          Order_Type=3;
                          break;
                  case 3: Price=Old_Price+(Dist_TP-20)*Poin;
                          TP=Old_Price-20*Poin;                     
                          Order_Type=5;
                 }                        
 //            Alert("     ",Order_Tip[i],"  ",Price,"  ",TP);
             int ticket=OrderSend(Symb, Order_Type, Lot, Price, 0, 0, TP);
      //--------------------------------------------------------- 7 --
//            if (ticket>0)                             //  :)
//              {
//               Alert ("   ",ticket,"  ",Price,"  ",TP);
//             }                                 
             }
          }
//-------------------------------------------------------------- 10 --
//   Alert ("   -----------------------------");
   return;                                      //   OnTick
  }
//--------------------------------------------------------------- 1 --
int GI_01(double a,double b,double c)
//+------------------------------------------------------------------+
//| a b c      0.00004                                                 |
//| 1,  a=b                                            |
//|           2       a=c                                            |
//|           0 -                                               |
//+------------------------------------------------------------------+
   {
      int d=0;
      if (MathAbs(a-b)<0.0001) d=1;
         else if (MathAbs(a-c)<0.0001) d=2;
         return(d);                                      
   }      
//+------------------------------------------------------------------+
   